<?php
namespace Models;

// Модель Программ лояльности
class Loyalty extends \DB\SQL\Mapper {
	public $db, $f3;

	public function __construct($db, $f3) {
		parent::__construct($db, 'loyalty' ); // подключаемся к таблице
		$this->db=$db;
		$this->f3=$f3;
	}

	// Выбор из базы
	function select_loyalty($query=null, $options=null) {
		$this->reset();
		$this->load($query, $options);
		$loyalty=array();
		if(!$this->dry()) {
			do {
				$loyalty[]=$this->cast();
			}
			while ($this->skip());
		}
		return $loyalty;
	}

	// Подбор программмы лояльности для добавленного товара
	function get_loyalty($client, $product, $parents) {
		$now=time(); // Время сейчас
		$w=date('w'); // Номер дня недели
		$h=sprintf("%'.02d", date('H')); // Час
		if($w==0)$w=7;
		//if(mb_strlen($h)<2)$h='0'.$h;
		$sql="SELECT * FROM `loyalty` WHERE `date_start`<=? AND `date_end`>=? AND `d".$w."` LIKE ? ";
		$val=array(
			$now,
			$now-3600*24,
			'%"'.$h.'":"1"%'
		);
		if($client==0) {
			$sql.=" AND `client`=0";
		}
		$sql.=" AND (`data` LIKE ?";
		$val[]='%"product_id":"'.$product['id'].'"%';
		if($parents && $parents[0]['id']>0) {
			foreach ($parents as $p) {
				$sql.=" OR `data` LIKE ?";
				$val[]='%"category_id":"'.$p['id'].'"%';
			}
		}
		$sql.=')';
		$loyalty=$this->db->exec($sql, $val);
		if($loyalty) {
			foreach ($loyalty as $n => $l) {
				$loyalty[$n]['items']=json_decode($l['data'], true);
			}
		}
		return $loyalty;
	}

	// Список скидок
	function select_discounts($discount=false) {
		$where='';
		$val=array();
		if($discount!==false) {
			$where='WHERE value=?';
			$val[]=$discount;
		}
		return $this->db->exec("SELECT * FROM discounts ".$where." ORDER BY value", $val);
	}
}
