<?php
namespace Models;

// Модель Категорий товаров
class Productcategories extends \DB\SQL\Mapper {
	public $db, $f3;

	public function __construct($db, $f3) {
		parent::__construct($db, 'productcategories' ); // подключаемся к таблице категорий товаров
		$this->db=$db;
		$this->f3=$f3;
	}

	// Выбор из базы
	function select_productcategories($query=null, $options=null) {
		// Ищем только не удаленные категории
		if(is_array($query)) {
			$query[0]='('.$query[0].') AND date_delete=0';
		}
		else {
			$query[0]='date_delete=0';
		}
		$this->reset();
		$this->load($query, $options);
		$categories=array();
		if(!$this->dry()) {
			do {
				$categories[]=$this->cast();
			}
			while ($this->skip());
		}
		return $categories;
	}

	// Поиск родительских категорий
	function get_parents($id) {
		$parents=array();
		do {
			$this->reset();
			$this->load(array('id=?', $id), array('limit'=>1));
			if(!$this->dry()) {
				$parents[]=$this->cast();
				$id=$this->parent_id;
			}
		}
		while(!$this->dry() && $this->parent_id>0);
		return $parents;
	}

	// Список категорий, включая подкатегории
	function find_cat($parent, $depth, $order) {
		$cat=$this->db->exec("SELECT * FROM productcategories WHERE date_delete=0 AND parent_id=? ORDER BY ".$order, $parent);
		if(!empty($cat)) {
			foreach($cat as $k=>$c) {
				$c['depth']=$depth;
				$categories[]=$c;
				$sub=$this->find_cat($c['id'], $depth+1, $order);
				if(!empty($sub)) {
					foreach($sub as $s) {
						$categories[]=$s;
					}
				}
			}
		}
		return $categories;
	}

	function categories_list($parent=0, $order='title') {
		return $categories=$this->find_cat($parent, 0, $order);
	}
}
